/*
 * eeprom.h
 *
 *  Created on: 2020. 4. 22.
 *      Author: parkyj
 */

#ifndef EEPROM_H_
#define EEPROM_H_

#define EEPROM_M24C08_ID                  0xA0
#define EEPROM_Block0_ADDRESS             EEPROM_M24C08_ID
#define EEPROM_ATT_BASE					  0x0000 + 96
                                             
#if 1 // PYJ.2020.04.25_BEGIN -- 
                                             
#define EEPROM_ATT_DL1_TABLE_ADDRESDS	 (( EEPROM_ATT_BASE                 + (sizeof(ATT_TABLE_st))   )  & 0xFFFF) //128
#define EEPROM_ATT_DL2_TABLE_ADDRESDS	 (( EEPROM_ATT_DL1_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  ) & 0xFFFF) 
#define EEPROM_ATT_DL3_TABLE_ADDRESDS	 (( EEPROM_ATT_DL2_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  ) & 0xFFFF)
#define EEPROM_ATT_DL4_TABLE_ADDRESDS	 (( EEPROM_ATT_DL3_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  ) & 0xFFFF)
#define EEPROM_ATT_UL1_TABLE_ADDRESDS	 (( EEPROM_ATT_DL4_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  )    & 0xFFFF)
#define EEPROM_ATT_UL2_TABLE_ADDRESDS	 (( EEPROM_ATT_UL1_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  )    & 0xFFFF)
#define EEPROM_ATT_UL3_TABLE_ADDRESDS	 (( EEPROM_ATT_UL2_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  )    & 0xFFFF)
#define EEPROM_ATT_UL4_TABLE_ADDRESDS	 (( EEPROM_ATT_UL3_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  )    & 0xFFFF)//128
#define EEPROM_DET_DL1_TABLE_ADDRESDS	 (( EEPROM_ATT_UL4_TABLE_ADDRESDS  + (sizeof(DET_TABLEDL_st)))    & 0xFFFF)
#define EEPROM_DET_DL2_TABLE_ADDRESDS	 (( EEPROM_DET_DL1_TABLE_ADDRESDS  + (sizeof(DET_TABLEDL_st)))    & 0xFFFF)
#define EEPROM_DET_DL3_TABLE_ADDRESDS	 (( EEPROM_DET_DL2_TABLE_ADDRESDS  + (sizeof(DET_TABLEDL_st)))    & 0xFFFF)
#define EEPROM_DET_DL4_TABLE_ADDRESDS	 (( EEPROM_DET_DL3_TABLE_ADDRESDS  + (sizeof(DET_TABLEDL_st)))    & 0xFFFF)
#define EEPROM_DET_UL1_TABLE_ADDRESDS	 (( EEPROM_DET_DL4_TABLE_ADDRESDS  + (sizeof(DET_TABLEUL_st)))     & 0xFFFF)
#define EEPROM_DET_UL2_TABLE_ADDRESDS	 (( EEPROM_DET_UL1_TABLE_ADDRESDS  + (sizeof(DET_TABLEUL_st)))     & 0xFFFF)
#define EEPROM_DET_UL3_TABLE_ADDRESDS	 (( EEPROM_DET_UL2_TABLE_ADDRESDS  + (sizeof(DET_TABLEUL_st)))     & 0xFFFF)
#define EEPROM_DET_UL4_TABLE_ADDRESDS	 (( EEPROM_DET_UL3_TABLE_ADDRESDS  + (sizeof(DET_TABLEUL_st)))     & 0xFFFF)
#define EEPROM_TEMP_DL1_TABLE_ADDRESDS	 (( EEPROM_DET_UL4_TABLE_ADDRESDS  + (sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_DL2_TABLE_ADDRESDS	 (( EEPROM_TEMP_DL1_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_DL3_TABLE_ADDRESDS	 (( EEPROM_TEMP_DL2_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_DL4_TABLE_ADDRESDS	 (( EEPROM_TEMP_DL3_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_UL1_TABLE_ADDRESDS	 (( EEPROM_TEMP_DL4_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_UL2_TABLE_ADDRESDS	 (( EEPROM_TEMP_UL1_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_UL3_TABLE_ADDRESDS	 (( EEPROM_TEMP_UL2_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_UL4_TABLE_ADDRESDS	 (( EEPROM_TEMP_UL3_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_USER_ATTEN_VALUE_ADDRESDS (( EEPROM_TEMP_UL4_TABLE_ADDRESDS +( sizeof(USER_ATTEN_st)+16))     & 0xFFFF)
#define EEPROM_WINDOW_STATUS_ADDRESDS	 ((EEPROM_USER_ATTEN_VALUE_ADDRESDS + (sizeof(BLUESTATUS_st))) & 0xFFFF) //96byte

#else
#define EEPROM_WINDOW_STATUS_ADDRESDS	 ((EEPROM_ATT_BASE + (sizeof(BLUESTATUS_st))) & 0xFFFF) //96byte
#define EEPROM_ATT_DL1_TABLE_ADDRESDS	 (( EEPROM_WINDOW_STATUS_ADDRESDS  + (sizeof(ATT_TABLE_st))  )& 0xFFFF) //128
#define EEPROM_ATT_DL2_TABLE_ADDRESDS	 (( EEPROM_ATT_DL1_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  ) & 0xFFFF) 
#define EEPROM_ATT_DL3_TABLE_ADDRESDS	 (( EEPROM_ATT_DL2_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  ) & 0xFFFF)
#define EEPROM_ATT_DL4_TABLE_ADDRESDS	 (( EEPROM_ATT_DL3_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  ) & 0xFFFF)
#define EEPROM_ATT_UL1_TABLE_ADDRESDS	 (( EEPROM_ATT_DL4_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  )    & 0xFFFF)
#define EEPROM_ATT_UL2_TABLE_ADDRESDS	 (( EEPROM_ATT_UL1_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  )    & 0xFFFF)
#define EEPROM_ATT_UL3_TABLE_ADDRESDS	 (( EEPROM_ATT_UL2_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  )    & 0xFFFF)
#define EEPROM_ATT_UL4_TABLE_ADDRESDS	 (( EEPROM_ATT_UL3_TABLE_ADDRESDS  + (sizeof(ATT_TABLE_st))  )    & 0xFFFF)//128
#define EEPROM_DET_DL1_TABLE_ADDRESDS	 (( EEPROM_ATT_UL4_TABLE_ADDRESDS  + (sizeof(DET_TABLEDL_st)))    & 0xFFFF)
#define EEPROM_DET_DL2_TABLE_ADDRESDS	 (( EEPROM_DET_DL1_TABLE_ADDRESDS  + (sizeof(DET_TABLEDL_st)))    & 0xFFFF)
#define EEPROM_DET_DL3_TABLE_ADDRESDS	 (( EEPROM_DET_DL2_TABLE_ADDRESDS  + (sizeof(DET_TABLEDL_st)))    & 0xFFFF)
#define EEPROM_DET_DL4_TABLE_ADDRESDS	 (( EEPROM_DET_DL3_TABLE_ADDRESDS  + (sizeof(DET_TABLEDL_st)))    & 0xFFFF)
#define EEPROM_DET_UL1_TABLE_ADDRESDS	 (( EEPROM_DET_DL4_TABLE_ADDRESDS  + (sizeof(DET_TABLEUL_st)))     & 0xFFFF)
#define EEPROM_DET_UL2_TABLE_ADDRESDS	 (( EEPROM_DET_UL1_TABLE_ADDRESDS  + (sizeof(DET_TABLEUL_st)))     & 0xFFFF)
#define EEPROM_DET_UL3_TABLE_ADDRESDS	 (( EEPROM_DET_UL2_TABLE_ADDRESDS  + (sizeof(DET_TABLEUL_st)))     & 0xFFFF)
#define EEPROM_DET_UL4_TABLE_ADDRESDS	 (( EEPROM_DET_UL3_TABLE_ADDRESDS  + (sizeof(DET_TABLEUL_st)))     & 0xFFFF)
#define EEPROM_TEMP_DL1_TABLE_ADDRESDS	 (( EEPROM_DET_UL4_TABLE_ADDRESDS  + (sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_DL2_TABLE_ADDRESDS	 (( EEPROM_TEMP_DL1_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_DL3_TABLE_ADDRESDS	 (( EEPROM_TEMP_DL2_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_DL4_TABLE_ADDRESDS	 (( EEPROM_TEMP_DL3_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_UL1_TABLE_ADDRESDS	 (( EEPROM_TEMP_DL4_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_UL2_TABLE_ADDRESDS	 (( EEPROM_TEMP_UL1_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_UL3_TABLE_ADDRESDS	 (( EEPROM_TEMP_UL2_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)
#define EEPROM_TEMP_UL4_TABLE_ADDRESDS	 (( EEPROM_TEMP_UL3_TABLE_ADDRESDS +( sizeof(TEMP_TABLE_st)))     & 0xFFFF)

#endif // PYJ.2020.04.25_END -- 



#define MAKE_ADDRESS(_addr, _e2)            ((uint8_t)EEPROM_M24C08_ADDR | \
                                             ((_e2) ? EEPROM_M24C08_ADDR_E2 : 0) | \
                                             ((uint8_t)((_addr) >> 7) & EEPROM_M24C08_BYTE_ADDR_H))

#define EEPROM_M24C08_ADDR                  0xA0        //!< M24C08 device identifier
#define EEPROM_M24C08_ADDR_E2               0x08        //!< M24C08 E2 address bit




#define EEPROM_M24C08_BYTE_ADDR_H           0x06

HAL_StatusTypeDef EEPROM_M24C08_Read(uint8_t devid,uint16_t Address,uint8_t* data,uint16_t size);
HAL_StatusTypeDef EEPROM_M24C08_write(uint8_t devid,uint16_t Address,uint8_t* data,uint16_t size);

HAL_StatusTypeDef EEPROM_M24C08_ByteRead(uint16_t devid,uint16_t Address,uint8_t* data,uint8_t size);
HAL_StatusTypeDef EEPROM_M24C08_Bytewrite(uint16_t devid,uint16_t Address,uint8_t* data,uint8_t size);
HAL_StatusTypeDef EEPROM_M24C08_Zerowrite(uint8_t devid,uint16_t Address);

void EEPROM_M24C08_Init(void);


typedef struct{
    uint8_t bluecell_User_DL1_H;  uint8_t bluecell_User_DL1_L;
    uint8_t bluecell_User_DL2_H;  uint8_t bluecell_User_DL2_L;
    uint8_t bluecell_User_DL3_H;  uint8_t bluecell_User_DL3_L;
    uint8_t bluecell_User_DL4_H;  uint8_t bluecell_User_DL4_L;
    uint8_t bluecell_User_UL1_H;  uint8_t bluecell_User_UL1_L;
    uint8_t bluecell_User_UL2_H;  uint8_t bluecell_User_UL2_L;
    uint8_t bluecell_User_UL3_H;  uint8_t bluecell_User_UL3_L;
    uint8_t bluecell_User_UL4_H;  uint8_t bluecell_User_UL4_L;
}USER_ATTEN_st;


typedef struct{
    uint8_t Table_0_0_dBm;
    uint8_t Table_0_5_dBm;
    uint8_t Table_1_0_dBm;
    uint8_t Table_1_5_dBm;
    uint8_t Table_2_0_dBm;
    uint8_t Table_2_5_dBm;
    uint8_t Table_3_0_dBm;
    uint8_t Table_3_5_dBm;
    uint8_t Table_4_0_dBm;
    uint8_t Table_4_5_dBm;
    uint8_t Table_5_0_dBm;
    uint8_t Table_5_5_dBm;
    uint8_t Table_6_0_dBm;
    uint8_t Table_6_5_dBm;
    uint8_t Table_7_0_dBm;
    uint8_t Table_7_5_dBm;
    uint8_t Table_8_0_dBm;
    uint8_t Table_8_5_dBm;
    uint8_t Table_9_0_dBm;
    uint8_t Table_9_5_dBm;
    uint8_t Table_10_0_dBm;
    uint8_t Table_10_5_dBm;
    uint8_t Table_11_0_dBm;
    uint8_t Table_11_5_dBm;
    uint8_t Table_12_0_dBm;
    uint8_t Table_12_5_dBm;
    uint8_t Table_13_0_dBm;
    uint8_t Table_13_5_dBm;
    uint8_t Table_14_0_dBm;
    uint8_t Table_14_5_dBm;
    uint8_t Table_15_0_dBm;
    uint8_t Table_15_5_dBm;
    uint8_t Table_16_0_dBm;
    uint8_t Table_16_5_dBm;
    uint8_t Table_17_0_dBm;
    uint8_t Table_17_5_dBm;
    uint8_t Table_18_0_dBm;
    uint8_t Table_18_5_dBm;
    uint8_t Table_19_0_dBm;
    uint8_t Table_19_5_dBm;
    uint8_t Table_20_0_dBm;
    uint8_t Table_20_5_dBm;
    uint8_t Table_21_0_dBm;
    uint8_t Table_21_5_dBm;
    uint8_t Table_22_0_dBm;
    uint8_t Table_22_5_dBm;
    uint8_t Table_23_0_dBm;
    uint8_t Table_23_5_dBm;
    uint8_t Table_24_0_dBm;
    uint8_t Table_24_5_dBm;
    uint8_t Table_25_0_dBm;
    uint8_t Table_25_5_dBm;
    uint8_t Table_26_0_dBm;
    uint8_t Table_26_5_dBm;
    uint8_t Table_27_0_dBm;
    uint8_t Table_27_5_dBm;
    uint8_t Table_28_0_dBm;
    uint8_t Table_28_5_dBm;
    uint8_t Table_29_0_dBm;
    uint8_t Table_29_5_dBm;
    uint8_t Table_30_0_dBm;
    uint8_t Table_30_5_dBm;
    uint8_t Table_31_0_dBm;
    uint8_t Table_31_5_dBm;
    uint8_t Table_xx_x_1_dBm;
    uint8_t Table_xx_x_2_dBm;
    uint8_t Table_xx_x_3_dBm;
    uint8_t Table_xx_x_4_dBm;
    uint8_t Table_xx_x_5_dBm;
    uint8_t Table_xx_x_6_dBm;
    uint8_t Table_xx_x_7_dBm;
    uint8_t Table_xx_x_8_dBm;
    uint8_t Table_xx_x_9_dBm;
    uint8_t Table_xx_x_10_dBm;
    uint8_t Table_xx_x_11_dBm;
    uint8_t Table_xx_x_12_dBm;
    uint8_t Table_xx_x_13_dBm;
    uint8_t Table_xx_x_14_dBm;
    uint8_t Table_xx_x_15_dBm;
    uint8_t Table_xx_x_16_dBm;
    uint8_t Table_xx_x_17_dBm;
    uint8_t Table_xx_x_18_dBm;
    uint8_t Table_xx_x_19_dBm;
    uint8_t Table_xx_x_20_dBm;
    uint8_t Table_xx_x_21_dBm;
    uint8_t Table_xx_x_22_dBm;
    uint8_t Table_xx_x_23_dBm;
    uint8_t Table_xx_x_24_dBm;
    uint8_t Table_xx_x_25_dBm;
    uint8_t Table_xx_x_26_dBm;
    uint8_t Table_xx_x_27_dBm;
    uint8_t Table_xx_x_28_dBm;
    uint8_t Table_xx_x_29_dBm;
    uint8_t Table_xx_x_30_dBm;
    uint8_t Table_Ref;
    uint8_t Table_Length;
}ATT_TABLE_st;
typedef struct{
    uint8_t Table_Det5_dBm_H	;
    uint8_t Table_Det5_dBm_L	;
    uint8_t Table_Det4_dBm_H	;
    uint8_t Table_Det4_dBm_L	;  
    uint8_t Table_Det3_dBm_H	;
    uint8_t Table_Det3_dBm_L	;
    uint8_t Table_Det2_dBm_H	;
    uint8_t Table_Det2_dBm_L	;
    uint8_t Table_Det1_dBm_H	;
    uint8_t Table_Det1_dBm_L	;
    uint8_t Table_Det0_dBm_H	;
    uint8_t Table_Det0_dBm_L	;
    uint8_t Table_Det_1_dBm_H	;
    uint8_t Table_Det_1_dBm_L	;
    uint8_t Table_Det_2_dBm_H	;
    uint8_t Table_Det_2_dBm_L	;
    uint8_t Table_Det_3_dBm_H	;
    uint8_t Table_Det_3_dBm_L	;
    uint8_t Table_Det_4_dBm_H	;
    uint8_t Table_Det_4_dBm_L	;
    uint8_t Table_Det_5_dBm_H	;
    uint8_t Table_Det_5_dBm_L	;  
    uint8_t Table_Det_6_dBm_H	;
    uint8_t Table_Det_6_dBm_L	;  
    uint8_t Table_Det_7_dBm_H	;
    uint8_t Table_Det_7_dBm_L	;
    uint8_t Table_Det_8_dBm_H	;
    uint8_t Table_Det_8_dBm_L	;
    uint8_t Table_Det_9_dBm_H	;
    uint8_t Table_Det_9_dBm_L	;
    uint8_t Table_Det_10_dBm_H	;
    uint8_t Table_Det_10_dBm_L	;  
    uint8_t Table_Det_11_dBm_H	;
    uint8_t Table_Det_11_dBm_L	;
    uint8_t Table_Det_12_dBm_H	;
    uint8_t Table_Det_12_dBm_L	;
    uint8_t Table_Det_13_dBm_H	;
    uint8_t Table_Det_13_dBm_L	;
    uint8_t Table_Det_14_dBm_H	;
    uint8_t Table_Det_14_dBm_L	;
    uint8_t Table_Det_15_dBm_H	;
    uint8_t Table_Det_15_dBm_L	;
    uint8_t Table_Det_16_dBm_H	;
    uint8_t Table_Det_16_dBm_L	;
    uint8_t Table_Det_17_dBm_H	;
    uint8_t Table_Det_17_dBm_L	;
    uint8_t Table_Det_18_dBm_H	;
    uint8_t Table_Det_18_dBm_L	;
    uint8_t Table_Det_19_dBm_H	;
    uint8_t Table_Det_19_dBm_L	;
    uint8_t Table_Det_20_dBm_H	;
    uint8_t Table_Det_20_dBm_L	;
    uint8_t Table_Det_21_dBm_H	;
    uint8_t Table_Det_21_dBm_L	;
    uint8_t Table_Det_22_dBm_H	;
    uint8_t Table_Det_22_dBm_L	;
    uint8_t Table_Det_23_dBm_H	;
    uint8_t Table_Det_23_dBm_L	;
    uint8_t Table_Det_24_dBm_H	;
    uint8_t Table_Det_24_dBm_L	;
    uint8_t Table_Det_25_dBm_H	;
    uint8_t Table_Det_25_dBm_L	;
    uint8_t Table_Det_xx1_dBm_H	;
    uint8_t Table_Det_xx1_dBm_L	;
    uint8_t Table_Det_xx2_dBm_H	;
    uint8_t Table_Det_xx2_dBm_L	;
    uint8_t Table_Det_xx3_dBm_H	;
    uint8_t Table_Det_xx3_dBm_L	;
    uint8_t Table_Det_xx4_dBm_H	;
    uint8_t Table_Det_xx4_dBm_L	;
    uint8_t Table_Det_xx5_dBm_H	;
    uint8_t Table_Det_xx5_dBm_L	;
    uint8_t Table_Det_xx6_dBm_H	;
    uint8_t Table_Det_xx6_dBm_L	;
    uint8_t Table_Det_xx7_dBm_H	;
    uint8_t Table_Det_xx7_dBm_L	;
    uint8_t Table_Det_xx8_dBm_H	;
    uint8_t Table_Det_xx8_dBm_L	;
    uint8_t Table_Det_xx9_dBm_H	;
    uint8_t Table_Det_xx9_dBm_L	;
    uint8_t Table_Det_xx10_dBm_H	;
    uint8_t Table_Det_xx10_dBm_L	;
    uint8_t Table_Det_xx11_dBm_H	;
    uint8_t Table_Det_xx11_dBm_L	;
    uint8_t Table_Det_xx12_dBm_H	;
    uint8_t Table_Det_xx12_dBm_L	;
    uint8_t Table_Det_xx13_dBm_H	;
    uint8_t Table_Det_xx13_dBm_L	;
    uint8_t Table_Det_xx14_dBm_H	;
    uint8_t Table_Det_xx14_dBm_L	;
    uint8_t Table_Det_xx15_dBm_H	;
    uint8_t Table_Det_xx15_dBm_L	;
    uint8_t Table_Det_xx16_dBm_H	;
    uint8_t Table_Det_xx16_dBm_L	;
    uint8_t Table_Det_xx17_dBm_H	;
    uint8_t Table_Det_xx17_dBm_L	;
    uint8_t Table_Det_xx18_dBm_H	;
    uint8_t Table_Det_xx18_dBm_L	;
    uint8_t Table_Det_xx19_dBm_H	;
    uint8_t Table_Det_xx19_dBm_L	;
    uint8_t Table_Det_xx20_dBm_H	;
    uint8_t Table_Det_xx20_dBm_L	;
    uint8_t Table_Det_xx21_dBm_H	;
    uint8_t Table_Det_xx21_dBm_L	;
    uint8_t Table_Det_xx22_dBm_H	;
    uint8_t Table_Det_xx22_dBm_L	;
    uint8_t Table_Det_xx23_dBm_H	;
    uint8_t Table_Det_xx23_dBm_L	;
    uint8_t Table_Det_xx24_dBm_H	;
    uint8_t Table_Det_xx24_dBm_L	;
    uint8_t Table_Det_xx25_dBm_H	;
    uint8_t Table_Det_xx25_dBm_L	;
    uint8_t Table_Det_xx26_dBm_H	;
    uint8_t Table_Det_xx26_dBm_L	;
    uint8_t Table_Det_xx27_dBm_H	;
    uint8_t Table_Det_xx27_dBm_L	;
    uint8_t Table_Det_xx28_dBm_H	;
    uint8_t Table_Det_xx28_dBm_L	;
    uint8_t Table_Det_xx29_dBm_H	;
    uint8_t Table_Det_xx29_dBm_L	;
    uint8_t Table_Det_xx30_dBm_H	;
    uint8_t Table_Det_xx30_dBm_L	;
    uint8_t Table_Det_xx31_dBm_H	;
    uint8_t Table_Det_xx31_dBm_L	;
    uint8_t Table_Det_xx32_dBm_H	;
    uint8_t Table_Det_xx32_dBm_L	;
    uint8_t Table_Det_xx33_dBm_H	;
    uint8_t Table_Det_xx33_dBm_L	;
    uint8_t Table_Det_xx34_dBm_H	;
    uint8_t Table_Det_xx34_dBm_L	;
    uint8_t Table_Det_xx35_dBm_H	;
    uint8_t Table_Det_xx35_dBm_L	;
    uint8_t Table_Det_xx36_dBm_H	;
    uint8_t Table_Det_xx36_dBm_L	;
    uint8_t Table_Det_xx37_dBm_H	;
    uint8_t Table_Det_xx37_dBm_L	;
    uint8_t Table_Det_xx38_dBm_H	;
    uint8_t Table_Det_xx38_dBm_L	;
    uint8_t Table_Det_xx39_dBm_H	;
    uint8_t Table_Det_xx39_dBm_L	;
    uint8_t Table_Det_xx40_dBm_H	;
    uint8_t Table_Det_xx40_dBm_L	;
    uint8_t Table_Det_xx41_dBm_H	;
    uint8_t Table_Det_xx41_dBm_L	;
    uint8_t Table_Det_xx42_dBm_H	;
    uint8_t Table_Det_xx42_dBm_L	;
    uint8_t Table_Det_xx43_dBm_H	;
    uint8_t Table_Det_xx43_dBm_L	;
    uint8_t Table_Det_xx44_dBm_H	;
    uint8_t Table_Det_xx44_dBm_L	;
    uint8_t Table_Det_xx45_dBm_H	;
    uint8_t Table_Det_xx45_dBm_L	;
    uint8_t Table_Det_xx46_dBm_H	;
    uint8_t Table_Det_xx46_dBm_L	;
    uint8_t Table_Det_xx47_dBm_H	;
    uint8_t Table_Det_xx47_dBm_L	;
    uint8_t Table_Det_xx48_dBm_H	;
    uint8_t Table_Det_xx48_dBm_L	;
    uint8_t Table_Ref	;
    uint8_t Table_Length	;
}DET_TABLEDL_st;
typedef struct{
      uint8_t Table_Det_15_dBm_H  ;   
      uint8_t Table_Det_15_dBm_L    ;
      uint8_t Table_Det_16_dBm_H    ;   
      uint8_t Table_Det_16_dBm_L    ;
      uint8_t Table_Det_17_dBm_H    ;   
      uint8_t Table_Det_17_dBm_L    ;
      uint8_t Table_Det_18_dBm_H    ;   
      uint8_t Table_Det_18_dBm_L    ;
      uint8_t Table_Det_19_dBm_H    ;   
      uint8_t Table_Det_19_dBm_L    ;
      uint8_t Table_Det_20_dBm_H    ;
      uint8_t Table_Det_20_dBm_L    ;
      uint8_t Table_Det_21_dBm_H    ;
      uint8_t Table_Det_21_dBm_L    ;
      uint8_t Table_Det_22_dBm_H    ;   
      uint8_t Table_Det_22_dBm_L    ;
      uint8_t Table_Det_23_dBm_H    ;   
      uint8_t Table_Det_23_dBm_L    ;
      uint8_t Table_Det_24_dBm_H    ;   
      uint8_t Table_Det_24_dBm_L    ;
      uint8_t Table_Det_25_dBm_H    ;   
      uint8_t Table_Det_25_dBm_L    ;
      uint8_t Table_Det_26_dBm_H    ;   
      uint8_t Table_Det_26_dBm_L    ;
      uint8_t Table_Det_27_dBm_H    ;   
      uint8_t Table_Det_27_dBm_L    ;
      uint8_t Table_Det_28_dBm_H    ;   
      uint8_t Table_Det_28_dBm_L    ;
      uint8_t Table_Det_29_dBm_H    ;   
      uint8_t Table_Det_29_dBm_L    ;
      uint8_t Table_Det_30_dBm_H    ;   
      uint8_t Table_Det_30_dBm_L    ;
      uint8_t Table_Det_31_dBm_H    ;   
      uint8_t Table_Det_31_dBm_L    ;
      uint8_t Table_Det_32_dBm_H    ;   
      uint8_t Table_Det_32_dBm_L    ;
      uint8_t Table_Det_33_dBm_H    ;   
      uint8_t Table_Det_33_dBm_L    ;
      uint8_t Table_Det_34_dBm_H    ;   
      uint8_t Table_Det_34_dBm_L    ;
      uint8_t Table_Det_35_dBm_H    ;   
      uint8_t Table_Det_35_dBm_L    ;
      uint8_t Table_Det_36_dBm_H    ;  
      uint8_t Table_Det_36_dBm_L    ;
      uint8_t Table_Det_37_dBm_H    ;  
      uint8_t Table_Det_37_dBm_L    ;
      uint8_t Table_Det_38_dBm_H    ;   
      uint8_t Table_Det_38_dBm_L    ;
      uint8_t Table_Det_39_dBm_H    ;  
      uint8_t Table_Det_39_dBm_L    ;
      uint8_t Table_Det_40_dBm_H    ;  
      uint8_t Table_Det_40_dBm_L    ;
      uint8_t Table_Det_41_dBm_H    ;  
      uint8_t Table_Det_41_dBm_L    ;
      uint8_t Table_Det_42_dBm_H    ; 
      uint8_t Table_Det_42_dBm_L    ;
      uint8_t Table_Det_43_dBm_H    ;  
      uint8_t Table_Det_43_dBm_L    ;
      uint8_t Table_Det_44_dBm_H    ;  
      uint8_t Table_Det_44_dBm_L    ;
      uint8_t Table_Det_45_dBm_H    ;  
      uint8_t Table_Det_45_dBm_L    ;
      uint8_t Table_Det_46_dBm_H    ;   
      uint8_t Table_Det_46_dBm_L    ;
      uint8_t Table_Det_47_dBm_H    ; 
      uint8_t Table_Det_47_dBm_L    ;
      uint8_t Table_Det_48_dBm_H    ;   
      uint8_t Table_Det_48_dBm_L    ;
      uint8_t Table_Det_49_dBm_H    ; 
      uint8_t Table_Det_49_dBm_L    ;
      uint8_t Table_Det_50_dBm_H    ;  
      uint8_t Table_Det_50_dBm_L    ;
      uint8_t Table_Det_51_dBm_H    ;  
      uint8_t Table_Det_51_dBm_L    ;
      uint8_t Table_Det_52_dBm_H    ;  
      uint8_t Table_Det_52_dBm_L    ;
      uint8_t Table_Det_53_dBm_H    ;  
      uint8_t Table_Det_53_dBm_L    ;
      uint8_t Table_Det_54_dBm_H    ;  
      uint8_t Table_Det_54_dBm_L    ;
      uint8_t Table_Det_55_dBm_H    ;  
      uint8_t Table_Det_55_dBm_L    ;
      uint8_t Table_Det_56_dBm_H    ;  
      uint8_t Table_Det_56_dBm_L    ;
      uint8_t Table_Det_57_dBm_H    ;  
      uint8_t Table_Det_57_dBm_L    ;
      uint8_t Table_Det_58_dBm_H    ;  
      uint8_t Table_Det_58_dBm_L    ;
      uint8_t Table_Det_59_dBm_H    ;  
      uint8_t Table_Det_59_dBm_L    ;
      uint8_t Table_Det_60_dBm_H    ;   
      uint8_t Table_Det_60_dBm_L    ;
      uint8_t Table_Det_XX1_dBm_H   ;   
      uint8_t Table_Det_XX1_dBm_L   ;
      uint8_t Table_Det_XX2_dBm_H   ;   
      uint8_t Table_Det_XX2_dBm_L   ;
      uint8_t Table_Det_XX3_dBm_H   ;   
      uint8_t Table_Det_XX3_dBm_L   ;
      uint8_t Table_Det_XX4_dBm_H   ;   
      uint8_t Table_Det_XX4_dBm_L   ;
      uint8_t Table_Det_XX5_dBm_H   ;   
      uint8_t Table_Det_XX5_dBm_L   ;
      uint8_t Table_Det_XX6_dBm_H   ;   
      uint8_t Table_Det_XX6_dBm_L   ;
      uint8_t Table_Det_XX7_dBm_H   ;   
      uint8_t Table_Det_XX7_dBm_L   ;
      uint8_t Table_Det_XX8_dBm_H   ;   
      uint8_t Table_Det_XX8_dBm_L   ;
      uint8_t Table_Det_XX9_dBm_H   ;   
      uint8_t Table_Det_XX9_dBm_L   ;
      uint8_t Table_Det_XX10_dBm_H  ;   
      uint8_t Table_Det_XX10_dBm_L  ;
      uint8_t Table_Det_XX11_dBm_H  ;   
      uint8_t Table_Det_XX11_dBm_L  ;
      uint8_t Table_Det_XX12_dBm_H  ;   
      uint8_t Table_Det_XX12_dBm_L  ;
      uint8_t Table_Det_XX13_dBm_H  ;   
      uint8_t Table_Det_XX13_dBm_L  ;
      uint8_t Table_Det_XX14_dBm_H  ;   
      uint8_t Table_Det_XX14_dBm_L  ;
      uint8_t Table_Det_XX15_dBm_H  ;   
      uint8_t Table_Det_XX15_dBm_L  ;
      uint8_t Table_Det_XX16_dBm_H  ;   
      uint8_t Table_Det_XX16_dBm_L  ;
      uint8_t Table_Det_XX17_dBm_H  ;   
      uint8_t Table_Det_XX17_dBm_L  ;
      uint8_t Table_Det_XX18_dBm_H  ;   
      uint8_t Table_Det_XX18_dBm_L  ;
      uint8_t Table_Det_XX19_dBm_H  ;   
      uint8_t Table_Det_XX19_dBm_L  ;
      uint8_t Table_Det_XX20_dBm_H  ;   
      uint8_t Table_Det_XX20_dBm_L  ;
      uint8_t Table_Det_XX21_dBm_H  ;   
      uint8_t Table_Det_XX21_dBm_L  ;
      uint8_t Table_Det_XX22_dBm_H  ;   
      uint8_t Table_Det_XX22_dBm_L  ;
      uint8_t Table_Det_XX23_dBm_H  ;   
      uint8_t Table_Det_XX23_dBm_L  ;
      uint8_t Table_Det_XX24_dBm_H  ;   
      uint8_t Table_Det_XX24_dBm_L  ;
      uint8_t Table_Det_XX25_dBm_H  ;   
      uint8_t Table_Det_XX25_dBm_L  ;
      uint8_t Table_Det_XX26_dBm_H  ;   
      uint8_t Table_Det_XX26_dBm_L  ;
      uint8_t Table_Det_XX27_dBm_H  ;   
      uint8_t Table_Det_XX27_dBm_L  ;
      uint8_t Table_Det_XX28_dBm_H  ;   
      uint8_t Table_Det_XX28_dBm_L  ;
      uint8_t Table_Det_XX29_dBm_H  ;   
      uint8_t Table_Det_XX29_dBm_L  ;
      uint8_t Table_Det_XX30_dBm_H  ;   
      uint8_t Table_Det_XX30_dBm_L  ;
      uint8_t Table_Det_XX31_dBm_H  ;   
      uint8_t Table_Det_XX31_dBm_L  ;
      uint8_t Table_Det_XX32_dBm_H  ;   
      uint8_t Table_Det_XX32_dBm_L  ;
      uint8_t Table_Det_XX33_dBm_H  ;   
      uint8_t Table_Det_XX33_dBm_L  ;
      uint8_t Table_Ref  ;   
      uint8_t Table_Length  ;
}DET_TABLEUL_st;

typedef struct{
  int8_t Table_1_Temp;   
  int8_t Table_2_Temp;
  int8_t Table_3_Temp;   
  int8_t Table_4_Temp;
  int8_t Table_5_Temp;   
  int8_t Table_6_Temp;
  int8_t Table_7_Temp;   
  int8_t Table_8_Temp;
  int8_t Table_9_Temp;   
  int8_t Table_10_Temp;
  int8_t Table_11_Temp;   
  int8_t Table_12_Temp;
  int8_t Table_13_Temp;   
  int8_t Table_14_Temp;
  int8_t Table_15_Temp;   
  int8_t Table_16_Temp;
  int8_t Table_17_Temp;   
  int8_t Table_18_Temp;
  int8_t Table_19_Temp;   
  int8_t Table_20_Temp;
  int8_t Table_21_Temp;   
  int8_t Table_22_Temp;
  int8_t Table_23_Temp;   
  int8_t Table_24_Temp;
  int8_t Table_25_Temp;   
  int8_t Table_26_Temp;
  int8_t Table_27_Temp;   
  int8_t Table_28_Temp;
  int8_t Table_29_Temp;   
  int8_t Table_30_Temp;  
  int8_t Table_Ref;
  int8_t Table_Length;
}TEMP_TABLE_st;


typedef struct{
    uint8_t bluecell_header;
    uint8_t bluecell_type;
    uint8_t bluecell_length;
    uint8_t bluecell_crcindex;
    uint8_t Selftest1;
    uint8_t Selftest2;
    uint8_t Selftest3;
    uint8_t Selftest4;
    uint8_t ATT_DL1_PATH;
    uint8_t ATT_DL2_PATH;
    uint8_t ATT_DL3_PATH;
    uint8_t ATT_DL4_PATH;
    uint8_t ATT_UL1_PATH;
    uint8_t ATT_UL2_PATH;
    uint8_t ATT_UL3_PATH;
    uint8_t ATT_UL4_PATH;
    uint8_t ATT_DL1_H;
    uint8_t ATT_DL1_L;
    uint8_t ATT_DL2_H;
    uint8_t ATT_DL2_L;
    uint8_t ATT_DL3_H;
    uint8_t ATT_DL3_L;
    uint8_t ATT_DL4_H;
    uint8_t ATT_DL4_L;
    uint8_t ATT_UL1_H;
    uint8_t ATT_UL1_L;
    uint8_t ATT_UL2_H;
    uint8_t ATT_UL2_L;
    uint8_t ATT_UL3_H;
    uint8_t ATT_UL3_L;
    uint8_t ATT_UL4_H;
    uint8_t ATT_UL4_L;
    uint8_t ULO_P1_Level1_H;
    uint8_t ULO_P1_Level1_L;
    uint8_t ULO_P2_Level2_H;
    uint8_t ULO_P2_Level2_L;
    uint8_t ULO_P3_Level3_H;
    uint8_t ULO_P3_Level3_L;
    uint8_t ULO_P4_Level4_H;
    uint8_t ULO_P4_Level4_L;
    uint8_t DLI_P1_Level1_H;
    uint8_t DLI_P1_Level1_L;
    uint8_t DLI_P2_Level2_H;
    uint8_t DLI_P2_Level2_L;
    uint8_t DLI_P3_Level3_H;
    uint8_t DLI_P3_Level3_L;
    uint8_t DLI_P4_Level4_H;
    uint8_t DLI_P4_Level4_L;    
    int8_t DET_TEMP;
    uint8_t DLI_AGC_ON_OFF;
    uint8_t ULO_ALC_ON_OFF;
    uint8_t ULO_Level1_H;
    uint8_t ULO_Level1_L;
    uint8_t ULO_Level2_H;
    uint8_t ULO_Level2_L;
    uint8_t ULO_Level3_H;
    uint8_t ULO_Level3_L;
    uint8_t ULO_Level4_H;
    uint8_t ULO_Level4_L;
    uint8_t DLI_Level1_H;
    uint8_t DLI_Level1_L;
    uint8_t DLI_Level2_H;
    uint8_t DLI_Level2_L;
    uint8_t DLI_Level3_H;
    uint8_t DLI_Level3_L;
    uint8_t DLI_Level4_H;
    uint8_t DLI_Level4_L; 
    uint8_t ULO_ALC_Threshold_H;
    uint8_t ULO_ALC_Threshold_L;
    uint8_t bluecell_User_DL1_H;  
    uint8_t bluecell_User_DL1_L;
    uint8_t bluecell_User_DL2_H;  
    uint8_t bluecell_User_DL2_L;
    uint8_t bluecell_User_DL3_H;  
    uint8_t bluecell_User_DL3_L;
    uint8_t bluecell_User_DL4_H;  
    uint8_t bluecell_User_DL4_L;
    uint8_t bluecell_User_UL1_H;  
    uint8_t bluecell_User_UL1_L;
    uint8_t bluecell_User_UL2_H;  
    uint8_t bluecell_User_UL2_L;
    uint8_t bluecell_User_UL3_H;  
    uint8_t bluecell_User_UL3_L;
    uint8_t bluecell_User_UL4_H;  
    uint8_t bluecell_User_UL4_L;
    uint8_t bluecell_User_TEMP_H;  
    uint8_t bluecell_User_TEMP_L;
    int8_t bluecell_User_TEMP_OFFSET;  
    int8_t Temp_High_Threshold;
    int8_t Temp_High_Threshold_Default;
    uint8_t DLI_Level_High_Threshold_H;
    uint8_t DLI_Level_High_Threshold_L;
    uint8_t DLI_Level_Low_Threshold_H;
    uint8_t DLI_Level_Low_Threshold_L;
    uint8_t DLI_Level_High_Low_Threshold_default;
    uint8_t ALARM_TEMP_HIGH; //bit
    uint8_t ALARM_DLI_Level;
    uint8_t ALARM_DLI_SHTUTDOWN;
    uint8_t ALARM_DLI_AGC_Alarm;
    uint8_t ALARM_ULO_ALC_Alarm;    
    uint8_t ALARM_ULO_Level;
    uint8_t ALARM_ULO_SHTUTDOWN;
    uint8_t ALARM_MASK1;
    uint8_t ALARM_MASK2;
    uint8_t ALARM_MASK3;
    uint8_t ALARM_MASK4;
    uint8_t ALARM_MASK5;
    uint8_t ALARM_TESTMODE;
    uint8_t ALARM_Test_Dummy1;
    uint8_t ALARM_Test_Dummy2;
    uint8_t ALARM_Test_Dummy3;
    uint8_t ALARM_Test_Dummy4;
    uint8_t ALARM_Test_Dummy5;    
    uint8_t CPUVERSION1;
    uint8_t CPUVERSION2;
    uint8_t CPUVERSION3;
    uint8_t CPU_Current_Bank;
    uint8_t CPU_Bank_Select;//Reboot_by;
    uint8_t CPU_Bank1_Image_Version1;
    uint8_t CPU_Bank1_Image_Version2;
    uint8_t CPU_Bank1_Image_Version3;    
    uint8_t CPU_Bank1_Image_BuildTime1;
    uint8_t CPU_Bank1_Image_BuildTime2;
    uint8_t CPU_Bank1_Image_BuildTime3;
    uint8_t CPU_Bank1_Image_BuildTime4;
    uint8_t CPU_Bank1_Image_BuildTime5;
    uint8_t CPU_Bank1_Image_BuildTime6;    
    uint8_t CPU_Bank1_Image_Name[32];
    uint8_t CPU_Bank2_Image_Version1;
    uint8_t CPU_Bank2_Image_Version2;
    uint8_t CPU_Bank2_Image_Version3;    
    uint8_t CPU_Bank2_Image_BuildTime1;
    uint8_t CPU_Bank2_Image_BuildTime2;
    uint8_t CPU_Bank2_Image_BuildTime3;
    uint8_t CPU_Bank2_Image_BuildTime4;
    uint8_t CPU_Bank2_Image_BuildTime5;
    uint8_t CPU_Bank2_Image_BuildTime6;
    uint8_t CPU_Bank2_Image_Name[32];
    uint8_t S_W_Reset;
    uint8_t Factory_Set_Initialization;
    uint8_t Temp_High_Alarm;
    uint8_t LED_TEST;
    uint8_t NODE;
    uint8_t Type;
    uint8_t PCB_Version[2];
    uint8_t Serial_Number[20]; // INDEX : 20
    uint8_t Manufacture;
    uint8_t Manufacture_Date[3];
    uint8_t Freq_ID;
    uint8_t Carrier_ID;
    uint8_t Carrier_ON_OFF;
    uint8_t DLI_Level_High_Alarm1;
    uint8_t DLI_Level_High_Alarm2;
    uint8_t DLI_Level_High_Alarm3;
    uint8_t DLI_Level_High_Alarm4;
    uint8_t DLI_Level_Low_Alarm1;
    uint8_t DLI_Level_Low_Alarm2;
    uint8_t DLI_Level_Low_Alarm3;
    uint8_t DLI_Level_Low_Alarm4;
    uint8_t DLI_FRBT_Atten1_H;
    uint8_t DLI_FRBT_Atten1_L;    
    uint8_t DLI_FRBT_Atten2_H;
    uint8_t DLI_FRBT_Atten2_L;    
    uint8_t DLI_FRBT_Atten3_H;
    uint8_t DLI_FRBT_Atten3_L;    
    uint8_t DLI_FRBT_Atten4_H;
    uint8_t DLI_FRBT_Atten4_L;    
    uint8_t DLI_FRBT_D_Day;
    uint8_t DLI_FRBT_Status;
    uint8_t DLI_AGC_Threshold_H;
    uint8_t DLI_AGC_Threshold_L;
    uint8_t DLI_AGC_Threshold_default;
    uint8_t DLI_Shutdown_ON_OFF;
    uint8_t DLI_Shutdown_Threshold_H;
    uint8_t DLI_Shutdown_Threshold_L;    
    uint8_t DLI_Shutdown_Threshold_Default;
    uint8_t DLI_Shutdown_Retry_Count1;
    uint8_t DLI_Shutdown_Retry_Count2;
    uint8_t DLI_Shutdown_Retry_Count3;
    uint8_t DLI_Shutdown_Retry_Count4;    
    uint8_t DLI_AGC_Alarm1;
    uint8_t DLI_AGC_Alarm2;
    uint8_t DLI_AGC_Alarm3;
    uint8_t DLI_AGC_Alarm4;
    uint8_t DLI_Shutdown_Alarm1;
    uint8_t DLI_Shutdown_Alarm2;
    uint8_t DLI_Shutdown_Alarm3;
    uint8_t DLI_Shutdown_Alarm4;
    uint8_t ULO_Level_High_Threshold_H;
    uint8_t ULO_Level_High_Threshold_L;
    uint8_t ULO_Level_High_Threshold_default;
    uint8_t ULO_Level_High_Alarm1;
    uint8_t ULO_Level_High_Alarm2;
    uint8_t ULO_Level_High_Alarm3;
    uint8_t ULO_Level_High_Alarm4;
    uint8_t ULO_ALC_Threshold_Default;
    uint8_t ULO_Shutdown_ON_OFF;
    uint8_t ULO_Shutdown_Threshold_H;
    uint8_t ULO_Shutdown_Threshold_L;    
    uint8_t ULO_Shutdown_Threshold_Default;
    uint8_t ULO_Shutdown_Retry_Count1;
    uint8_t ULO_Shutdown_Retry_Count2;
    uint8_t ULO_Shutdown_Retry_Count3;
    uint8_t ULO_Shutdown_Retry_Count4;    
    uint8_t ULO_ALC_Alarm1;
    uint8_t ULO_ALC_Alarm2;
    uint8_t ULO_ALC_Alarm3;
    uint8_t ULO_ALC_Alarm4;
    uint8_t ULO_Shutdown_Alarm1;
    uint8_t ULO_Shutdown_Alarm2;
    uint8_t ULO_Shutdown_Alarm3;
    uint8_t ULO_Shutdown_Alarm4;
    uint8_t MBIC_ULO_ALC_Atten1_H;
    uint8_t MBIC_ULO_ALC_Atten1_L;
    uint8_t MBIC_ULO_ALC_Atten2_H;
    uint8_t MBIC_ULO_ALC_Atten2_L;
    uint8_t MBIC_ULO_ALC_Atten3_H;
    uint8_t MBIC_ULO_ALC_Atten3_L;
    uint8_t MBIC_ULO_ALC_Atten4_H;
    uint8_t MBIC_ULO_ALC_Atten4_L;
    int8_t MBIC_DLI_P1_Level_Table_Ref;
    int8_t MBIC_DLI_P2_Level_Table_Ref;
    int8_t MBIC_DLI_P3_Level_Table_Ref;
    int8_t MBIC_DLI_P4_Level_Table_Ref;
    int8_t MBIC_ULO_P1_Level_Table_Ref;
    int8_t MBIC_ULO_P2_Level_Table_Ref;
    int8_t MBIC_ULO_P3_Level_Table_Ref;
    int8_t MBIC_ULO_P4_Level_Table_Ref;
    int8_t MBIC_TEMP_DL_P1_Level_Table_Ref;
    int8_t MBIC_TEMP_DL_P2_Level_Table_Ref;
    int8_t MBIC_TEMP_DL_P3_Level_Table_Ref;
    int8_t MBIC_TEMP_DL_P4_Level_Table_Ref;
    int8_t MBIC_TEMP_UL_P1_Level_Table_Ref;
    int8_t MBIC_TEMP_UL_P2_Level_Table_Ref;
    int8_t MBIC_TEMP_UL_P3_Level_Table_Ref;
    int8_t MBIC_TEMP_UL_P4_Level_Table_Ref;
    int8_t MBIC_DLI_P1_Table_Length;
    int8_t MBIC_DLI_P2_Table_Length;
    int8_t MBIC_DLI_P3_Table_Length;
    int8_t MBIC_DLI_P4_Table_Length;
    int8_t MBIC_ULO_P1_Table_Length;
    int8_t MBIC_ULO_P2_Table_Length;
    int8_t MBIC_ULO_P3_Table_Length;
    int8_t MBIC_ULO_P4_Table_Length;
    int8_t MBIC_DLI_P1_Level_Table_Length;
    int8_t MBIC_DLI_P2_Level_Table_Length;
    int8_t MBIC_DLI_P3_Level_Table_Length;
    int8_t MBIC_DLI_P4_Level_Table_Length;
    int8_t MBIC_ULO_P1_Level_Table_Length;
    int8_t MBIC_ULO_P2_Level_Table_Length;
    int8_t MBIC_ULO_P3_Level_Table_Length;
    int8_t MBIC_ULO_P4_Level_Table_Length;
    int8_t MBIC_TEMP_DL_P1_Level_Table_Length;
    int8_t MBIC_TEMP_DL_P2_Level_Table_Length;
    int8_t MBIC_TEMP_DL_P3_Level_Table_Length;
    int8_t MBIC_TEMP_DL_P4_Level_Table_Length;
    int8_t MBIC_TEMP_UL_P1_Level_Table_Length;
    int8_t MBIC_TEMP_UL_P2_Level_Table_Length;
    int8_t MBIC_TEMP_UL_P3_Level_Table_Length;
    int8_t MBIC_TEMP_UL_P4_Level_Table_Length;
    uint8_t BLUECELL_RESERVE49;
    uint8_t BLUECELL_RESERVE50;
    uint8_t BLUECELL_RESERVE51;
    uint8_t BLUECELL_RESERVE52;
    uint8_t BLUECELL_RESERVE53;
    uint8_t bluecell_crc_H;
    uint8_t bluecell_crc_L;
    uint8_t bluecell_etx;

}BLUESTATUS_st;


// Exported functions ---------------------------------------------------------



// ----------------------------------------------------------------------------


#endif /* EEPROM_H_ */
